//////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2003, The Institute for Genomic Research (TIGR), Rockville,
// Maryland, U.S.A.  All rights reserved.
//////////////////////////////////////////////////////////////////////////////
#include "Custom7.h"
#include "AnnotationItem.h"
#include "Options.h"
#include "DataDescrip.h"
#include "RegionPrediction.h"
#include <vector>
#include <algorithm>
#include <fstream.h>
#include <math.h>

using std::cout;
using std::cerr;
using std::endl;

#if _RUNTIME_DEBUG >= 2
bool MYDEBUG = false;
#endif
Custom7* Custom7::_instance = NULL;
// This is some ugly ass shit I know!!!
// need to fix up class PlaceHolders....

static AnnotationScore bound(const AnnotationScore& );
static AnnotationScore getProb(const RegionPrediction& rp, EvScores::Bnd_t bnd, dsu::Strand_t strnd, int exonCnt); 

void Custom7::createTree(const string& rstr, const string& vstr) {
  const Options& opt = *Options::getInstance();
  if( opt.isLinComb() ) return;
  string rdir = rstr;
  if( rdir[rdir.size()-1] != '/' ) {
    rdir += '/';
  }
  const int num_vecs = 3;
  if( rstr.size() ) {
    const string astr = rdir + "acc.dt.dt";
    const string astrv = rdir + "acc.con";
    const DataDescrip& descripAcc = *(getFeatMaps()[EvScores::eAcc]);
    _dTree[EvScores::eAcc] = new DTree(astr,astrv,descripAcc,num_vecs);

    const string dstr = rdir + "don.dt.dt";
    const string dstrv = rdir + "don.con";
    const DataDescrip& descripDon = *(getFeatMaps()[EvScores::eDon]); 
    _dTree[EvScores::eDon] = new DTree(dstr,dstrv,descripDon,num_vecs);

    const string cstr = rdir + "code.dt.dt";
    const string cstrv = rdir + "code.con";
    const DataDescrip& descripCod = *(getFeatMaps()[EvScores::eCoding]); 
    _dTree[EvScores::eCoding] = new DTree(cstr,cstrv,descripCod,num_vecs);

    const string sstr = rdir + "start.dt.dt";
    const string sstrv = rdir + "start.con";
    const DataDescrip& descripStart= *(getFeatMaps()[EvScores::eStart]); 
    _dTree[EvScores::eStart] = new DTree(sstr,sstrv,descripStart,num_vecs);
    
    const string pstr = rdir + "stop.dt.dt";
    const string pstrv = rdir + "stop.con";
    const DataDescrip& descripStop= *(getFeatMaps()[EvScores::eStop]); 
    _dTree[EvScores::eStop] = new DTree(pstr,pstrv,descripStop,num_vecs);
  }
}

#if 0
void Custom7::readDiscreteVals(const string& str) {
  Custom7* cs = getInstance();
  ifstream ifs(str.c_str());
  if( !ifs) {
    cerr<<"error: "<<str<<endl;
    exit(1);
  }
  for(unsigned i = 0; i < EvScores::eNumBnd; ++i) {
    const DataDescrip& dd = *((cs->getFeatMaps())[i]); 
    FeatVec* vec = NULL;
    vector<double>& disvec = cs->getDisVec(i);
    double qv = pow(2,(double)dd.getDiscSize());
    disvec.resize( (unsigned)qv );
    for(unsigned j = 0; j < disvec.size(); ++j) {
      disvec[j] = 0;
    }
    unsigned cnt = 0;
    while( (vec=dd.read(ifs)) ) {
      double val;
      ifs>>val;
      unsigned num = vec->getBinNum();
      assert(num < disvec.size());
      disvec[num] = val;
      if( cnt >= disvec.size() -2 )
	break;
      ++cnt;
    }
  }
#if _RUNTIME_DEBUG >= 2
  for(unsigned i = 0; i < EvScores::eNumBnd; ++i) {
    const vector<double>& disvec = cs->getDisVec(i);
    for(unsigned j = 0; j < disvec.size(); ++j) {
      cout<<"["<<j<<"-"<<disvec[j]<<"]";
      if( j < disvec.size()-1 ) {
      } else
	cout<<endl;
    }
  }
#endif
}
#endif

CustomScore::LabelScore Custom7::score(const RegionPrediction& rp, const string& str) const {
  assert(0);
  CustomScore::LabelScore vals(2);
  return vals;
}

#define CBEST

void Custom7::score(vector<RegionPrediction*>& vrp, const string& str) const {
  int middle = (vrp.size()-1)/2;
  // this method considers only physically adjacent vectors
  // when this is on the distance metric will not be used
  if( vrp[middle-1] ) {
    int leftGap = vrp[middle]->getEnd5()-vrp[middle-1]->getEnd3();
    vrp[middle-1] = leftGap > 1 ? NULL : vrp[middle-1]; 
  }
  if( vrp[middle+1] ) {
    int rghtGap = vrp[middle+1]->getEnd5()-vrp[middle]->getEnd3();
    vrp[middle+1] = rghtGap > 1 ? NULL : vrp[middle+1];
  }
  CustomScore::LabelScore vals(2);
  vals[dsu::eNeg] = scoreHelp(vrp,str,dsu::eNeg);
  vals[dsu::ePos] = scoreHelp(vrp,str,dsu::ePos);
  RegionPrediction& rp = *vrp[middle];
  if( !rp.noStrndData(dsu::ePos)) {
    rp.setScores(dsu::ePos,vals[dsu::ePos]);
  }
  if( !rp.noStrndData(dsu::eNeg)) {
    rp.setScores(dsu::eNeg,vals[dsu::eNeg]);
  }
}

EvScores Custom7::scoreHelp(const vector<RegionPrediction*>& rpv, const string& str, dsu::Strand_t strnd) const {
  // we will assume (for now) that the 
  // we are scoring the middle rp of a odd number of vectors
  int middle = (rpv.size()-1)/2;
  if( rpv[middle]->noStrndData(strnd) ) return EvScores();
#if _RUNTIME_DEBUG >= 1
  bool localDebug = false;
  if(rpv[middle]->getEnd5() == 65364 && strnd == dsu::ePos ) {
    MYDEBUG = localDebug = true;
    cout<<*rpv[middle]<<endl;
  } else {
    MYDEBUG = false;
  }
#endif
  double leftGap = 1;
  if( rpv[middle-1] ) {
    leftGap = rpv[middle]->getEnd5()-rpv[middle-1]->getEnd3();
    leftGap = 1 - (1/leftGap);
  } else {
    leftGap = 1;
  }
  double rghtGap = 1;
  if( rpv[middle+1] ) {
    rghtGap = rpv[middle+1]->getEnd5()-rpv[middle]->getEnd3();
    rghtGap = 1 - (1/rghtGap);
  } else {
    rghtGap = 1;
  }
  assert(middle >= 1);
  assert(middle+1 < (signed)rpv.size());
  vector< vector<FeatVec*> > vecofvec(rpv.size());
  for(unsigned i = 0; i < vecofvec.size(); ++i) {
    vecofvec[i] = calcVec(rpv[i],strnd);
  }
  EvScores scores;
  const Options& opt = *Options::getInstance();
  bool isLinComb = opt.isLinComb();
  for(unsigned i = 0; i < EvScores::eNumBnd; ++i) {
    assert(isLinComb);
    scores[i] = bound(vecofvec[middle][EvScores::eCoding]->sumEval());
  }
  if( scores[EvScores::eCoding]==0 ) {
    scores[EvScores::eCoding] = AnnotationScore::badVal();
  }
  return scores;
}

static AnnotationScore bound(const AnnotationScore& in_score) {
  AnnotationScore score = in_score;
  const double code_thresh = 1.0;
  score  = score > code_thresh ? 1 : score;
  score  = score < 0 ? 0 : score;
  return score;
}
double Custom7::getProb(const AnnotationItem& item, EvScores::Bnd_t cbnd, dsu::Strand_t strnd) const {
  const RegionPrediction& rp = item.getRegionPrediction();
  double prb = ::getProb(rp,cbnd,strnd,0).getVal();
  return prb;
}

/*
** The parse is a conjunction of probabilities 
** so to get the most probable sequence we would 
** normally minimized the -log sum , becuase I already
** was doing a maximizing score, I'm taking 1-prob
*/
static AnnotationScore getProb(const RegionPrediction& rp, EvScores::Bnd_t bnd, dsu::Strand_t strnd, int exonCnt) {
  assert(exonCnt >= 0);
  const Options& opt = *(Options::getInstance());
  bool linComb = opt.isLinComb();
  assert(linComb);
  AnnotationScore val = -1;
  if( linComb ) {
    if( bnd == EvScores::eNonCoding ) {
      EvScores scP = rp.getScores(dsu::ePos);
      EvScores scN = rp.getScores(dsu::eNeg);
      AnnotationScore max = AnnotationScore::badVal();
      AnnotationScore ps = scP[EvScores::eCoding];
      if( ps != AnnotationScore::badVal() && ps > max ) {
	max = ps;
      }
      AnnotationScore ns = scN[EvScores::eCoding];
      if( ns != AnnotationScore::badVal() && ns > max ) {
	max = ns;
      }
      if( max != AnnotationScore::badVal() ) 
	val = (1-max);
      else 
	val = 1;
    } else {
      assert(strnd != dsu::eEither);
      EvScores sc = rp.getScores(strnd);
      val = sc[EvScores::eCoding].getVal();
    }
  }
  if( val != AnnotationScore::badVal() && (val < 0 || val > 1) ) {
    cout<<"huh? val: "<<val<<endl;
    cout<<rp<<endl;
    assert( val >= 0 && val <= 1);
  }
  
  return val*rp.length();
}
